#!/bin/bash
if [ $# -ne 2 ]; then
    echo "Usage: $0 <file_path>"
    exit 1
fi


current_develop(){
    cmdline=$(cat /proc/cmdline)
    ostree_param=$(echo $cmdline | grep -o 'ostree=[^ ]*')

    if [ -z "$ostree_param" ]; then
    	echo "ostree= 引导项未找到"
    	exit 1
	fi
    # 获取 ostree= 参数的值（即文件路径）
	ostree_path=$(echo $ostree_param | cut -d'=' -f2)
    # 使用 readlink 获取真实文件链接
	real_path=$(readlink -f $ostree_path)
	if [ $? -ne 0 ]; then
    	echo "无法解析 ostree 路径: $ostree_path"
    	exit 1
    else
        echo "获取到当前的部署路径$real_path"
        etc_copy="${real_path}/usr"
        var_copy="${real_path}/"
   
        if [ "$1" == "etc" ];then
            if [ -d "$2" ];then
                echo "---copy $2---"
                if [ -d "$etc_copy${2}" ];then
                    if rsync -r -ac --inplace --xattrs --links $2/* $etc_copy${2}; then
                        echo "rsync 同步成功: $2 → $etc_copy${2}"
                        if sed -i "\|${2}</path>|a \      <status>completed</status>" "/etc/ostree/ost-ex.d/ostree_coredata.xml"; then
                            echo "成功添加 <status>completed</status> 到 ${2} 节点"
                        else
                            echo "错误：无法修改 XML 文件"
                            exit 1
                        fi
                    else
                        echo "错误：rsync 同步失败: $2"
                    fi
                else
                    mkdir -p $etc_copy${2}
                    rsync -r -ac --inplace --xattrs --links $2/* $etc_copy${2}
                fi
            else
                echo "---copy $2---"
                if [ -d "$etc_copy$(dirname "$2")" ];then
                    if rsync -r -ac --inplace --xattrs --links $2 "$etc_copy$(dirname "$2")"; then
                        echo "rsync 同步成功: $2 → $etc_copy${2}"
                        if sed -i "\|${2}</path>|a \      <status>completed</status>" "/etc/ostree/ost-ex.d/ostree_coredata.xml"; then
                            echo "成功添加 <status>completed</status> 到 ${2} 节点"
                        else
                            echo "错误：无法修改 XML 文件"
                            exit 1
                        fi
                    else
                        echo "错误：rsync 同步失败: $2"
                    fi
                else
                    mkdir -p "$etc_copy$(dirname "$2")"
                    rsync -r -ac --inplace --xattrs --links $2 "$etc_copy$(dirname "$2")"
                fi
            fi
        else
            if [ -d "$2" ];then
                echo "---copy $2---"
                if [ -d "$var_copy${2}" ];then
                    rsync -r -ac --inplace --xattrs --links $2/* $var_copy${2}
                else
                    mkdir -p $var_copy${2}
                    rsync -r -ac --inplace --xattrs --links $2/* $var_copy${2}
                fi
            else
                if [ -d "$var_copy$(dirname "$2")" ];then
                    rsync -r -ac --inplace --xattrs --links $2 "$var_copy$(dirname "$2")"
                else
                    mkdir -p "$var_copy$(dirname "$2")"
                    rsync -r -ac --inplace --xattrs --links $2 "$var_copy$(dirname "$2")"
                fi
            fi
        fi
    fi
}

type="$1"
path="$2"
current_develop $type $path


